namespace Syntriax.Engine.Core;

/// <summary>
/// Represents a <see cref="IBehaviour"/> to be notified before the draw phase of the <see cref="IUniverse"/> occurs.
/// </summary>
public interface IPreDraw : IBehaviour
{
    /// <summary>
    /// Updates the state of the <see cref="IBehaviour"/> before the main draw phase happens.
    /// </summary>
    void PreDraw();
}
