using Syntriax.Engine.Core;

namespace Syntriax.Engine.Physics2D;

/// <summary>
/// Represents a <see cref="IBehaviour"/> that listens to physics simulation update phase.
/// </summary>
public interface IPhysicsUpdate : IBehaviour
{
    /// <summary>
    /// Updates the physics state of the object based on the elapsed time since the last update.
    /// </summary>
    /// <param name="delta">The time elapsed since the last physics update.</param>
    void PhysicsUpdate(float delta);
}
