using Syntriax.Engine.Core;

namespace Syntriax.Engine.Physics2D;

/// <summary>
/// Represents a <see cref="IBehaviour"/> that listens to the phase before the physics simulation phase.
/// </summary>
public interface IPrePhysicsUpdate : IBehaviour
{
    /// <summary>
    /// Execute logic that should occur before the physics simulation is updated.
    /// </summary>
    /// <param name="delta">The time elapsed since the last physics update.</param>
    void PrePhysicsUpdate(float delta);
}
