using Syntriax.Engine.Core;

namespace Syntriax.Engine.Systems.Input;

public interface IButtonInputs<T> : IHasStateEnable
{
    Event<IButtonInputs<T>, ButtonCallbackArguments> OnAnyButtonPressed { get; }
    Event<IButtonInputs<T>, ButtonCallbackArguments> OnAnyButtonReleased { get; }

    void RegisterOnPress(T button, Event<IButtonInputs<T>, ButtonCallbackArguments>.EventHandler callback);
    void UnregisterOnPress(T button, Event<IButtonInputs<T>, ButtonCallbackArguments>.EventHandler callback);
    void RegisterOnRelease(T button, Event<IButtonInputs<T>, ButtonCallbackArguments>.EventHandler callback);
    void UnregisterOnRelease(T button, Event<IButtonInputs<T>, ButtonCallbackArguments>.EventHandler callback);

    bool IsPressed(T button);

    readonly record struct ButtonCallbackArguments(T Button);
}
